#pragma once
#include "B4RDefines.h"
#include "Adafruit_ST7735.h"
#include "rAdafruitGFX.h"
//~version: 1.00
namespace B4R {
	//~shortname: AdafruitST7735
	class B4RST7735 {
		private:
			uint8_t be[sizeof(Adafruit_ST7735)];
			Adafruit_ST7735* st;
			B4RAdafruitGFX gfx;
			void init(Byte options);
		public:
			//Gets the graphics object. Make sure to call Display to apply the changes.
			B4RAdafruitGFX* GFX;
			//Use with any pins you like.
			//Options: 0 = ST7735R green tab, 1 = ST7735R red tab, 2 = ST7735R black tab, 3 = ST7735B.
			void InitializeSoftware(Byte CS, Byte DC, Byte SID, Byte SCLK, Byte RST, Byte Options);
			//Use with hardware SPI pins. On UNO SCLK = 13, SID = 11 and pin 10 must be set to output.
			//Options: 0 = ST7735R green tab, 1 = ST7735R red tab, 2 = ST7735R black tab, 3 = ST7735B.
			void InitializeHardware(Byte CS, Byte DC, Byte RST, Byte Options);
			void FillScreen (UInt Color);
			//Rotation should be between 0 to 3.
			void SetRotation(Byte Rotation);
			UInt Color (Byte R, Byte G, Byte B);
			#define /*UInt COLOR_BLACK;*/ B4RAdafruitST7735_COLOR_BLACK ST7735_BLACK 
			#define /*UInt COLOR_BLUE;*/ B4RAdafruitST7735_COLOR_BLUE ST7735_BLUE 
			#define /*UInt COLOR_GREEN ;*/ B4RAdafruitST7735_COLOR_GREEN  ST7735_GREEN  
			#define /*UInt COLOR_CYAN;*/ B4RAdafruitST7735_COLOR_CYAN ST7735_CYAN 
			#define /*UInt COLOR_RED;*/ B4RAdafruitST7735_COLOR_RED ST7735_RED 
			#define /*UInt COLOR_MAGENTA;*/ B4RAdafruitST7735_COLOR_MAGENTA ST7735_MAGENTA 
			#define /*UInt COLOR_YELLOW;*/ B4RAdafruitST7735_COLOR_YELLOW ST7735_YELLOW 
			#define /*UInt COLOR_WHITE ;*/ B4RAdafruitST7735_COLOR_WHITE  ST7735_WHITE  
	};
}